import React from 'react';
import { ViewStyle } from 'react-native';

type PreviewMedia = {
    id: string;
    type: 'video' | 'image' | 'render';
    uri?: string;
    onDeletePress?: () => void;
    onSaveMediaPress?: () => void;
    onEditPress?: () => void;
    onReplacePress?: () => void;
    extra: any;
    render?: (
        isFocused: boolean,
        setEnableScroll: (scrollEnabled: boolean) => void,
        setShowControls: (showControls: boolean) => void,
        getScrollEnabled: () => boolean,
        getShowControls: () => boolean,
    ) => JSX.Element;
}

type MediaPreviewCarouselProps = {
    medias: PreviewMedia[];
    initialIndex?: number;
    renderMediaExtra?: (media: PreviewMedia) => any;
    onDragDown?: () => void;
    /** if you set a `imageSizeExtractor`, it avoids calling Image.getSize every time the picture is focused */
    imageSizeExtractor?: (media: PreviewMedia) => ({ width: number, height: number } | undefined);
    errorTitle: string;
    errorMessage: string;
    statusBarStyle?: 'light-content' | 'dark-content';
    /** override the style of the carousel */
    style?: ViewStyle;
    onIndexChanged?: (newIndex: number) => void;
    unavailableVideoPreviewMessage?: string;
}

export class MediaPreviewCarousel extends React.Component<MediaPreviewCarouselProps> {

}
